#version 430

layout (location = 0) in vec2 mesh_xy;
layout (location = 1) in vec2 mesh_uv;

layout (location = 2) in vec2 instance_xbasis;
layout (location = 3) in vec2 instance_ybasis;
layout (location = 4) in vec2 instance_origin;
layout (location = 5) in vec4 instance_tint;
layout (location = 6) in float instance_depth;
layout (location = 7) in vec4 instance_rect;

layout (location = 0) out vec4 color;
layout (location = 1) out vec2 uv;

layout (binding = 0) uniform View {
	mat4 projection_matrix;
};

void main() {
	const vec2 world_position = instance_origin + mesh_xy.x * instance_xbasis + mesh_xy.y * instance_ybasis;
	const vec2 projected_position = (projection_matrix * vec4(world_position, 0, 1)).xy;
	const vec2 rect_size = instance_rect.zw - instance_rect.xy;
	const vec4 screen_position = vec4(projected_position, instance_depth, 1.0);

	gl_Position = screen_position;
	color = instance_tint;
	uv = instance_rect.xy + (mesh_uv * rect_size);
}
